;; $Id: privacy-fieldref-fieldset.tst,v 1.2 2005/04/18 20:34:23 leavens Exp leavens $
(newline)
(displayln "Test case of $Date: 2005/04/18 20:34:23 $")
(newline)

(run-regression-tests-equal?
 `(
   ( (run
"class point extends object
  field x
  field y
  public method initialize() 1

let p = new point()
in begin
     fieldset p x = 1;
     fieldset p y = 2;
     list(fieldref p x, fieldref p y)
   end
")
     ==> (1 2) )

   ( (run
"class point extends object
  field x
  field y
  public method initialize() 1

let p = new point()
    p2 = new point()
in begin
     fieldset p x = 1;
     fieldset p y = 2;
     fieldset p2 x = 7;
     fieldset p2 y = 34;
     list(fieldref p x, fieldref p y, fieldref p2 x, fieldref p2 y)
   end
")
     ==> (1 2 7 34) )

   ( (run
"class point extends object
  field x
  field y
  public method initialize() 1

class colorpoint extends point
  field color
  public method initialize() 1

class foo extends object
  field bar
  field baz
  public method initialize () 1

let cp = new colorpoint()
    p = new point()
    o = new foo()
    id = proc(x) x
in begin
     fieldset p x = 1;
     fieldset p y = 2;
     fieldset (id cp) x = +(5, 3);
     fieldset (id (id cp)) y = +(fieldref p x, fieldref (id p) y);
     fieldset (id (id (id cp))) color = 87;
     fieldset (id (id (id (id cp)))) color = +(1, fieldref cp color);
     fieldset o bar = 17;
     fieldset o baz = *(2,fieldref o bar);
     fieldset new foo() bar = 4;
     list(fieldref p x, fieldref p y,
          fieldref cp x, fieldref cp y, fieldref cp color,
          fieldref o bar, fieldref o baz)
   end
")
     ==> (1 2 8 3 88 17 34) )

   ( (run
"class dllist extends object
  public method initialize() 1
class double extends dllist
  field val
  field next
  field prev
  public method initialize() 1

let n1 = new double()
    n2 = new double()
in begin
     fieldset n1 val = 1;
     fieldset n2 val = 2;
     fieldset n1 next = n2;
     fieldset n2 next = n1;
     fieldset fieldref fieldref n1 next next prev = fieldref n1 next;
     fieldset fieldref fieldref n2 next next prev = fieldref n2 next;
     list(fieldref n1 val, fieldref n2 val,
          fieldref fieldref n1 next val,
          fieldref fieldref fieldref n1 next next val,
          fieldref fieldref n2 next val,
          fieldref fieldref fieldref n1 next next val,
          fieldref fieldref n2 prev val,
          fieldref fieldref fieldref n1 prev prev val,
          fieldref fieldref n1 prev val,
          fieldref fieldref fieldref n1 prev prev val)
   end
")
     ==> (1 2 2 1 1 1 1 1 2 1) )
   )
 )
