;; $Id: privacy-instanceof.tst,v 1.2 2005/04/18 20:15:03 leavens Exp leavens $

(newline)
(displayln "Test case of $Date: 2005/04/18 20:15:03 $")
(newline)

(run-regression-tests-equal?
 `(
   ( (run "class c1 extends object
           public method initialize () 1
         class c2 extends c1
           public method initialize () 1
         let o1 = new c1()
             o2 = new c2()
         in if instanceof o2 c2
            then list(instanceof o1 c1, instanceof o2 c1)
            else 55")
     ==> (1 1) )
   ( (run "class c1 extends object
           public method initialize () 1
         class c2 extends c1
           public method initialize () 1
         class c3 extends c2
           public method initialize () 1
         let o1 = new c1()
             o2 = new c2()
             o3 = new c3()
         in list(instanceof o1 c1, instanceof o2 c1, instanceof o3 c1,
                 instanceof o1 c2, instanceof o2 c2, instanceof o3 c2,
                 instanceof o1 c3, instanceof o2 c3, instanceof o3 c3)")
     ==> (1 1 1 0 1 1 0 0 1) )
   ( (run
"class point extends object
  field x
  field y
  public method initialize(initx, inity)
    begin set x = initx; set y = inity end
  public method getx() x
  public method gety() y
  public method equals (pt2)
    if instanceof pt2 point
    then let x2 = send pt2 getx()
             y2 = send pt2 gety()
         in if equal?(x,x2)
            then equal?(y,y2)
            else 0
    else 0

class colorpoint extends point
  field color
  public method initialize(initx, inity, initcolor)
    begin
      super initialize(initx, inity);
      set color = initcolor
    end
  public method set_color (c) set color = c
  public method get_color () color
  public method equals (pt2)
    if instanceof pt2 colorpoint
    then let c2 = send pt2 get_color()
         in if equal?(color, c2)
            then super equals(pt2)
            else 0
    else 0

class foo extends object
  public method initialize () 1

let cp1 = new colorpoint(1, 5, 87)
    cp2 = new colorpoint(1, 5, 93)
    cp3 = new colorpoint(1, 6, 87)
    p1 = new point(2, 6)
    p2 = new point(1, 5)
    o = new foo()
in list(send cp1 equals(cp1), send cp1 equals(cp2), send cp1 equals(cp3),
        send cp1 equals(p1), send cp1 equals(p2), send cp1 equals(o),
        send cp2 equals(cp1), send cp2 equals(cp2), send cp2 equals(cp3),
        send cp2 equals(p1), send cp2 equals(p2), send cp2 equals(o),
        send cp3 equals(cp1), send cp3 equals(cp2), send cp3 equals(cp3),
        send cp3 equals(p1), send cp3 equals(p2), send cp3 equals(o),
        send p1 equals(cp1), send p1 equals(cp2), send p1 equals(cp3),
        send p1 equals(p1), send p1 equals(p2), send p1 equals(o),
        send p2 equals(cp1), send p2 equals(cp2), send p2 equals(cp3),
        send p2 equals(p1), send p2 equals(p2), send p2 equals(o))
")
     ==> (1 0 0 0 0 0    ;; send cp1
	  0 1 0 0 0 0    ;; send cp2
	  0 0 1 0 0 0    ;; send cp3
	  0 0 0 1 0 0    ;; send p1
	  1 1 0 0 1 0) ) ;; send p2
   )
 )
