;; $Id: privacy.tst,v 1.2 2005/04/19 16:37:51 leavens Exp leavens $

(newline)
(displayln "Test case of $Date: 2005/04/19 16:37:51 $")
(newline)

(run-regression-tests-equal?
 `(
   ( (run "
class c1 extends object
  public method initialize () 1
  private method mpriv () 2
  protected method mprot () send self mpriv()
  public method mpub () send self mprot()

let o1 = new c1() in send o1 mpub()")
     ==> 2 )

   ( (run "
class c1 extends object
  public method initialize () 1
  protected method mprot () send self mprot2()
  protected method mprot2 () 2
  public method mpub () send self mprot()

class c2 extends c1
  public method initialize () 1
  private method mpriv2 () send self mprot()
  protected method mprot () super mprot ()
  public method mpub () send self mpriv2()

let o2 = new c2() in list(send o2 mpub(), send new c1() mpub())")
     ==> (2 2) )

   ( (run "
class c1 extends object
  public method initialize () 1
  private method mpriv () 2
  protected method mprot () send self mpriv()
  public method mpub () send self mprot()

class c2 extends c1
  public method initialize () 1
  private method mpriv2 () send self mprot()
  protected method mprot () super mprot ()
  public method mpub () send self mpriv2()

let o2 = new c2() in list(send o2 mpub(), send new c1() mpub())")
     ==> (2 2) )

   ( (run "
class c1 extends object
  field x
  public method initialize (y) send self setx(y)
  private method setx(y) set x = y
  private method getx() x
  public method equals(o2)
     equal?(send self getx(), send o2 getx())
      
let o1 = new c1(3)
    o2 = new c1(3)
in if send o1 equals(o2) then 5 else 20")
     ==> 5 )

   ( (run "
class c1 extends object
  field x
  public method initialize (y) send self setx(y)
  protected method setx(y) set x = y
  protected method getx() x
  public method equals(o2)
     equal?(send self getx(), send o2 getx())
      
let o1 = new c1(3)
    o2 = new c1(3)
in if send o1 equals(o2) then 6 else 5")
     ==> 6 )

   ( (run "
class c1 extends object
  field x
  protected method initialize (y) send self setx(y)
  protected method setx(y) set x = y
  protected method getx() x
  public method equals(o2)
     equal?(send self getx(), send o2 getx())

class c2 extends c1
  field y
  public method initialize (ix,iy)
    begin super initialize(ix); send self sety(iy) end
  protected method sety(iy) set y = iy
  protected method gety() y
  public method equals(o2)
     if equal?(send self gety(), send o2 gety())
     then equal?(send self getx(), send o2 getx())
     else 0
      
let o1 = new c2(3,4)
    o2 = new c2(3,4)
in if send o1 equals(o2) then 7 else 5")
     ==> 7 )

   )
 )

(displayln "After getting the above tests to work,")
(displayln "you also need to run tests, as in the homework statement")
(displayln "that show how your program detects errors.")
(displayln "See the homework text for examples that should generate errors.")
